
/*
 * Hardware requirements 
 * 1x 1" RGBDigit's on a RGBdigitSchield (Digit1) or breadboard 
 * 1x Arduino UNO
 
 * Arduino 16.1 with Adafruit_NeoPixel
 
 * Power Arduino up  Load software

  
 *****************************************Important*********************************************************************************************
 *
 * Important NOTE  Do not connect RGBDigitshield to a life arduino(UNO) controller 
 *
 *****************************************Important*********************************************************************************************
 * NOTE  The NeoPixel's are very sensitive for the correct connection order                                                           *
 * NOTE  See for more info the Basic Connection section on http://learn.adafruit.com/adafruit-neopixel-uberguide/arduino-library      *
  
 **************************************************************************************************************************************
 
 created 2015   by RGBDigit < http://rgbdigit.com >
 modified 19 Mrt 2015
 by Coen   RGBDigit
 Version C1RD_V15.01.01
 
 This code is based on Adafruit_NeoPixel  URL  http://learn.adafruit.com/adafruit-neopixel-uberguide/arduino-library 
  This example code is in the public domain.

*/

#include "Wire.h"                                             
#include <Adafruit_NeoPixel.h>                               

#define PIN 12                                               // Sending neopixel data to Pin 12 

// Parameter 1 = number of pixels in strip
// Parameter 2 = pin number (most are valid)
// Parameter 3 = pixel type flags, add together as needed:

Adafruit_NeoPixel strip = Adafruit_NeoPixel(8, PIN, NEO_GRB + NEO_KHZ800);

////////////////////////////////////////////////////////////////////////////////////////////////////

byte digit1 = 0; 

byte Red = 0; byte Green = 0; byte Blue = 0;
byte id = 0;
byte segmtloop = 0;
byte Lednum = 0;
byte Bright = 25; 
byte color_scheme = 4;


//-------------Color array  8 RGBleds = 1 RGBSegments----------------------------------------------------------------------------------------------------------------------------------------------------
              // a  b  c  d  e  f  g  h   
byte Rarray[] = {0, 0, 0, 0, 0, 0, 0, 0, };// array van 8
byte Garray[] = {0, 0, 0, 0, 0, 0, 0, 0, };// array van 48
byte Barray[] = {0, 0, 0, 0, 0, 0, 0, 0, };// array van 48

//------character table------------------------------------------------------------------------------

//            2-dimensional array of segment a,b,c,d,e,f,g,h data:   each character has its own colum
//                                          0 1 2 3 4 5 6 7 8 9 c - off
              byte  segmtarray [8][13] = { {1,0,1,1,0,1,0,1,1,1,1,0,0},    //a             a
                                           {1,1,1,1,1,0,0,1,1,1,0,0,0},    //b          f     b
                                           {1,1,0,1,1,1,1,1,1,1,0,0,0},    //c             g
                                           {1,0,1,1,0,1,1,0,1,1,0,0,0},    //d          e     c
                                           {1,0,1,0,0,0,1,0,1,0,0,0,0},    //e             d
                                           {1,0,0,0,1,1,1,0,1,1,1,0,0},    //f
                                           {0,0,1,1,1,1,1,0,1,1,1,1,0},    //g  
                                           {0,0,0,0,0,0,0,0,0,0,0,0,0},};  //h   


void setup() {
               strip.begin();
               strip.show();                            // Initialize all pixels to 'off'
               strip.setBrightness(Bright);      	// For safety (to prevent too high of a power draw), the test case defaults to 40
                      
               delay(500);                              // sanity check delay - allows reprogramming if accidently blowing power w/leds
               Wire.begin();
               Serial.begin(9600);                      // open een seriele port 
              }

//----------Main loop---------------------------------------------------------------------------

void loop() { 
              delay(50);                                         
              digit1 = 0 ;                            // set digit1 to 0 
 
             if (color_scheme == 0)                   // loop color_scheme from 0 to 4
                  {color_scheme = 4;}
             else 
                  {color_scheme-- ;}         
       
             
             while (digit1 < 10 ){
                delay(550);                            // counting speed
                Serial.print("color_scheme =  "); Serial.println(color_scheme );
                run_color_scheme();      
                translate_digits();                    // translate digit1 values to led's with color settings
                digit1++;                              // increment digit1 + 1
                Stream_LEDdata();                      // shift led data to pin 12 refresh colors
             }
            }                                             
//---------end main loop----------------------------------------------------------------------



//---------------------------------------------------------------
void translate_digits(){                               // translate digit1 values to led's with color settings
 
                Lednum =0;
                segmtloop =0;
              
                      while (segmtloop < 8)                          // translate digit1
                      { if (segmtarray [segmtloop][digit1]== 1)
                             { run_color_scheme(); 
                               Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                               Lednum++ ; } 
                        else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                               Lednum++ ; }
                        segmtloop++ ; 
                      }
                } 

//-----------------------------------------------------------------------------
void Stream_LEDdata(){
                        id = 0;
                        while (id < 8)
                          {   strip.setPixelColor(id, Rarray[id], Garray[id],  Barray[id]);   //leds[id] = CRGB(Garray[id], Rarray[id], Barray[id]);             
                              id++; 
                          } 
                        strip.show();
                        delay(10);
                      }

//-----run color scheme---------------------------------------------- 
void run_color_scheme(){
           switch (color_scheme){
                            case 1: 
                                  Green =  random(250);
                                  Red =  random(250);
                                  Blue =  random(250);
                            break;
                            case 2:   
                                  Green = random(10,100);
                                  Red =  100;   
                                  Blue = 0;         
                            break;
                            case 3:   
                                  Green = 130;  
                                  Red =  0;   
                                  Blue = random(10,200);     
                            break;
                            case 4:   
                                  Green = 0; 
                                  Red =  random(10,200);   
                                  Blue = 170;     
                            break;    
                        }
            }  


