
/*
 * Hardware requirements 
 * 1x 4x 1" RGBDigit's on a RGBdigitSchield
 * 1x DS3231 clock unit on the RGBDigitshield 
 * 1x IR remote set on the RGBDigitshield works fine with the red remote see URL list 
 * 1x Arduino UNO
 
 * Arduino 16.1 with Adafruit_NeoPixel and IRremote library
 
 * Power Arduino up  Load software
 * Use P(ower) key for jump into the menu
 * press B (menu B) for setting brightness or press C (menu C) for clock adjstment   button A has no function yet 
 * in Menu B use arrow up/down to adjust brightness  use O button to leave the menu
 * In Menu C use arrow left/right to choose digit to adjust and use arrow up/down to set digit
 * in Menu C use O button to store new time or the power button to leave C Menu
 *            -----------
 *           |      P     | layout RED remote control  see below for URL
 *           |   A  B  C  |
 *           |            |
 *           |            |
 *           |      ˄     |
 *           |   ˂  0  ˃  |   
 *           |      ˅     |
 *           |            |
 *            ------------ 
 *****************************************Important*********************************************************************************************
 *
 * Important NOTE  Do not connect RGBDigitshield to a life arduino(UNO) controller 
 *
 *****************************************Important*********************************************************************************************
 * NOTE  The NeoPixel's are very sensitive for the correct connection order                                                           *
 * NOTE  See for more info the Basic Connection section on http://learn.adafruit.com/adafruit-neopixel-uberguide/arduino-library      *
  
 **************************************************************************************************************************************
 
 created 2015   by RGBDigit < http://rgbdigit.com >
 modified 4 Apr 2015
 by Coen   RGBDigit
 Version SCLD_V15.01.01
 
 This code is based on Adafruit_NeoPixel  URL  http://learn.adafruit.com/adafruit-neopixel-uberguide/arduino-library 
 and a remote control.                    URL  http://floris.cc/shop/en/general-components/803-infrared-remote-control-.html 
 This example code is in the public domain.

*/

#include "Wire.h"                                             
#include <Adafruit_NeoPixel.h>                               
#include <IRremote.h>
#include <DS3231.h>

#define PIN 12                                               // Sending neopixel data to Pin 12 

// Parameter 1 = number of pixels in strip
// Parameter 2 = pin number (most are valid)
// Parameter 3 = pixel type flags, add together as needed:

Adafruit_NeoPixel strip = Adafruit_NeoPixel(32, PIN, NEO_GRB + NEO_KHZ800);

////////////////////////////////////////////////////////////////////////////////////////////////////

byte digit1 = 0; byte digit2 = 0; byte digit3 = 0; byte digit4 = 0; byte digit5 = 0; byte digit6 = 0;
byte digit11 = 1; byte digit22 = 4; 

byte Red = 0; byte Green = 0; byte Blue = 0;
byte id = 0;
byte segmtloop = 0;
byte Lednum = 0;
byte Bright = 25; byte Bright_step = 5;
byte color_scheme = 2;

byte Menu_num = 0; byte Menu_color = 0;

byte hour_h = 0;  byte hour_l = 0;
int  min_h = 0;   int  min_l = 0;
byte sec_h = 0;   byte sec_l = 0;

int hundreds = 0; int tenths = 0;

DS3231 Clock;
bool Century=false;
bool h12;
bool PM;
byte ADay, AHour, AMinute, ASecond, ABits;
bool ADy, A12h, Apm;
byte Hour, Minute, Second;

byte year, month, date, DoW, hour, minute, second;

bool Run_blink = 0; byte blink_count = 0;
 
//----------IR settings---------------------------------------------
int IR_VAL = 0;
const int RECV_PIN = 10;
IRrecv irrecv(RECV_PIN);
decode_results results;
#define POWER 0x10EFD827 
#define P 0x10EFD827 
#define A 0x10EFF807 
#define B 0x10EF7887
#define C 0x10EF58A7
#define UP 0x10EFA05F
#define DOWN 0x10EF00FF
#define LEFT 0x10EF10EF
#define RIGHT 0x10EF807F
#define SELECT 0x10EF20DF


//-------------Color array  48 RGBleds = 6 RGBSegments----------------------------------------------------------------------------------------------------------------------------------------------------
              // a  b  c  d  e  f  g  h |a  b  c  d  e  f  g  h |a  b  c  d  e  f  g  h |a  b  c  d  e  f  g  h |a  b  c  d  e  f  g  h |a  b  c  d  e  f  g  h  
byte Rarray[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};// array van 48
byte Garray[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};// array van 48
byte Barray[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};// array van 48

//------character table------------------------------------------------------------------------------

//            2-dimensional array of segment a,b,c,d,e,f,g,h data:   each character has its own colum
//                                          0 1 2 3 4 5 6 7 8 9 c - off
              byte  segmtarray [8][13] = { {1,0,1,1,0,1,0,1,1,1,1,0,0},    //a             a
                                           {1,1,1,1,1,0,0,1,1,1,0,0,0},    //b          f     b
                                           {1,1,0,1,1,1,1,1,1,1,0,0,0},    //c             g
                                           {1,0,1,1,0,1,1,0,1,1,0,0,0},    //d          e     c
                                           {1,0,1,0,0,0,1,0,1,0,0,0,0},    //e             d
                                           {1,0,0,0,1,1,1,0,1,1,1,0,0},    //f
                                           {0,0,1,1,1,1,1,0,1,1,1,1,0},    //g  
                                           {0,0,0,0,0,0,0,0,0,0,0,0,0},};  //h   


void setup() {
               strip.begin();
               strip.show();                     // Initialize all pixels to 'off'
               strip.setBrightness(Bright);      	// For safety (to prevent too high of a power draw), the test case defaults to 40
                      
//---------------------------------------------------------------
         	    // sanity check delay - allows reprogramming if accidently blowing power w/leds
               delay(500);
               Wire.begin();
               Serial.begin(9600); // open een seriele port

//----------IR settings---------------------------------------------  
               irrecv.enableIRIn(); // Start the receiver   
              }

//----------Main loop---------------------------------------------------------------------------

void loop() { 
               delay(950);                                       // +/-1 second interval      
               read_ir();
               Serial.print("Main loop "); Serial.println(IR_VAL ); 

                    read_clock();                                // read time and fill digit1,digit2,digit3,digit4 (unit conversion)
                    run_menu_color(5);                           // set RGB colors for main loop 

                    translate_digits();                          // use thei line for some random clock colors

                    if (blink_count > 1){                        // After 5 blinks refresh colors
                          translate_digits_no_new_color();       // shift led data to pin 12 with no new colors
                          blink_count--;}                        
                    else {
                          Stream_LEDdata();                      // shift led data to pin 12 refresh colors
                          blink_count = 5;}  
                          
                    Blink_DP();                                  // blink DP  
                    
               switch (IR_VAL){                                  // jump to main menu when power button is pressed
                               case 10:
                                       Menu_num = 1; 
                                       Main_menu();
                               break;
                               default: 
                               break;
                 
                               }
               irrecv.resume();                                  // Receive the next IR value
            }                                             
//---------end main loop----------------------------------------------------------------------
void Blink_DP(){
                        if (Run_blink == 0){        
                            strip.setPixelColor(15, 100, 100,  100);      // set DP on
                            strip.setPixelColor(31, 100, 100,  100);      // set DP on
                            Run_blink = 1;}
                        else {
                            strip.setPixelColor(15, 0, 0,  0);               // turn of DP
                            strip.setPixelColor(31, 0, 0,  0);               // turn of DP
                            Run_blink = 0; }
                        strip.show();
}
//-------Main menu loop-----------------------------------
void Main_menu() {
     Menu_color = 1;
     set_menu_color(Menu_color);
     while (Menu_num == 1) {
                             Serial.print("Main menu loop "); Serial.println(IR_VAL );
                             delay(500);
                             IR_VAL = 0;
                             read_ir();
                             
                             switch (IR_VAL) {
                                               case 10:
                                                       IR_VAL = 0;
                                                       Menu_num = 0;                  
                                               break;
                                               case 11:                                        // goto Menu Alarm
                                                       IR_VAL = 0;
                                                       Serial.println("Goto Alarm loop ");
                                                       Menu_num = 2; Menu_color = 2;
                                                       set_menu_color(Menu_color);
                                                       set_alarm();
                                               break;  
                                               case 12:                                        // goto Menu Bright
                                                       IR_VAL = 0;
                                                       Serial.println("Goto Brightness loop ");
                                                       Menu_num = 3; Menu_color = 3;
                                                       set_menu_color(Menu_color);
                                                       set_bright();
                                               break;  
                                               case 13:                                        // goto Menu Clock
                                                       IR_VAL = 0;
                                                       Serial.println("Goto Clock loop ");
                                                       Menu_num = 4; Menu_color = 4;
                                                       set_menu_color(Menu_color);
                                                       set_clock();
                                               break;           
                                             }        //end menu loop
                           }                          //exit menu loop
                }  
//-------Set Menu color-----------------------------------
void set_menu_color(int c){
                           run_menu_color(c);                          // set rgb colors nr c
                           translate_digits_no_new_color();
                           Stream_LEDdata();
                           strip.setPixelColor(15, 0, 0, 0);           // turn of DP
                           strip.show();                                    
                          }
//-------Set Menu color-clock----------------------------------
void show_set_clock_data(int p){
                                 run_menu_color(4);                    // set rgb colors nr 4
                                 translate_digits_no_new_color(); 
                                 Stream_LEDdata();
                                 strip.setPixelColor(p, 0,200, 0);     // set DP 
                                 strip.show();                                    
                               }

//-------Set_Alarm loop------IR 11--"A"-----------------------------
 void set_alarm(){
     while (Menu_num == 2) { 
                             read_ir();
                             switch (IR_VAL) {
                                               case 16:      
                                                       IR_VAL = 0;
                                                       Serial.println("Alarm loop ");
                                               break;  
                                               case 17:     
                                                       IR_VAL = 0;
                                                       Serial.println("Alarm loop ");
                                               break; 
                                               case 18:     
                                                       IR_VAL = 0;
                                                       Serial.println("end Alarm loop ");
                                                       Menu_num = 1;
                                                       return Main_menu();
                                               break;   
                                             }
                           } 
                 }
//-------Show Bright loop----------------------
void show_bright(){
                   if (Bright > 245 )
                      {Bright == 0; } 
                   hundreds = Bright % 1000;
                   tenths = hundreds % 100;
                   digit3 = tenths %10;                            // one  units  eenheden
                   digit2 = (tenths - digit3)/10;                  // tenths      tien tallen
                   digit1 = (hundreds - tenths)/100;               // hundreds    honderd tallen
                   digit4 = 12;                                    // no chracter empty ditigt
 
                   translate_digits_no_new_color();
                   strip.setBrightness(Bright);
                   Stream_LEDdata();
                   strip.show();//LEDS.show();      
                  }

//-------Set_bright loop------IR 12---"B"--------------------------
 void set_bright(){

     show_bright();

     while (Menu_num == 3) { 
                             read_ir();
                             switch (IR_VAL) {
                                               case 14:      
                                                       IR_VAL = 0;
                                                       Serial.println("Brightness loop Up ");
                                                       Bright += Bright_step;
                                                       Serial.println(Bright);
                                                       show_bright();
                                               break;  
                                               case 15:     
                                                       IR_VAL = 0;
                                                       Serial.println("Brightness loop Down");
                                                       Bright -= Bright_step;
                                                       Serial.println(Bright);
                                                       show_bright();
                                               break; 
                                               case 18:     
                                                       IR_VAL = 0;
                                                       Serial.println("end Brightness loop ");
                                                       Menu_num = 1;
                                                       return Main_menu();
                                               break;   
                                             }
                           } 
 }
//-------Set_Clock loop------IR 13--"C"-----------------------------
 void set_clock(){
       byte Digit_pointer = 1;
       byte Digit_array[5] = {0,7,15,23,31};
       byte Digit_num = 7; //Point_array[Array_pointer];
       
            read_clock();                                    //set clock data
            translate_digits_no_new_color();
            Stream_LEDdata();
            Digit_num = Digit_array[Digit_pointer];          // set Digit 1 Decimal pointer on               
            strip.setPixelColor(Digit_num, 0,200, 0);
            strip.show();//LEDS.show();
                 
   while (Menu_num == 4) { 
       read_ir();

       switch (IR_VAL) {
         case 10:                                            // exit Clock Menu
                 IR_VAL = 0;
                 Menu_num = 1;
                 return Main_menu();
         break; 
         
         case 14:      
                 IR_VAL = 0;
                        switch (Digit_pointer) {
                         case 1:  
                                 Serial.println(" digit1 Up ");
                                 if (digit1 < 2 ){digit1 ++;}
                                 Serial.println(digit1);
                                 show_set_clock_data(Digit_num);  
                                 break;
                         case 2:  
                                 Serial.println(" digit2 Up ");
                                 if (digit2 < 9 ){digit2 ++;}
                                 Serial.println(digit1);
                                 show_set_clock_data(Digit_num);  
                                 break;
                         case 3:  
                                 Serial.println(" digit3 Up ");
                                 if (digit3 < 5 ){digit3 ++;}
                                 Serial.println(digit3);
                                 show_set_clock_data(Digit_num);  
                                 break;
                         case 4:  
                                 Serial.println(" digit4 Up ");
                                 if (digit4 < 9 ){digit4 ++;}
                                 Serial.println(digit4);
                                 show_set_clock_data(Digit_num);  
                                 break;                                 
                               }                              
         break;           

         case 15:      
                 IR_VAL = 0;
                       switch (Digit_pointer) {
                         case 1:  
                                 Serial.println(" digit1 Up ");
                                 if (digit1 > 0 ){digit1 --;}
                                 Serial.println(digit1);
                                 show_set_clock_data(Digit_num);                                 
                                 break;
                         case 2:  
                                 Serial.println(" digit2 Up ");
                                 if (digit2 > 0 ){digit2 --;}
                                 Serial.println(digit1);
                                 show_set_clock_data(Digit_num);                                 
                                 break;
                         case 3:  
                                 Serial.println(" digit3 Up ");
                                 if (digit3 > 0 ){digit3 --;}
                                 Serial.println(digit3);
                                 show_set_clock_data(Digit_num);                                 
                                 break;
                         case 4:  
                                 Serial.println(" digit4 Up ");
                                 if (digit4 > 0 ){digit4 --;}
                                 Serial.println(digit4);
                                 show_set_clock_data(Digit_num);
                                 break;  
                               }                 
         break; 
         
         case 16:      
                 IR_VAL = 0;                                      // button Left
                 Serial.println("Clock move pointer left ");
                 Digit_num = Digit_array[Digit_pointer];           // Decimal piont off      
                 strip.setPixelColor(Digit_num, 0 ,0 , 0);                 
                 strip.show();//LEDS.show();
                 
                 if (Digit_pointer > 1 ){                          // move to next Decimal piont on
                 Digit_pointer -- ;
                 Digit_num = Digit_array[Digit_pointer];}                 
                 strip.setPixelColor(Digit_num, 0,200, 0);
                 strip.show();//LEDS.show();
         break;  
         case 17:                                                   // button Right      
                 IR_VAL = 0;
                 Serial.println("Clock move pointer right");
                 Digit_num = Digit_array[Digit_pointer];             // Decimal piont off        
                 strip.setPixelColor(Digit_num, 0 ,0 , 0);                 
                 strip.show();//LEDS.show();
                 
                 if (Digit_pointer < 4 ){                            // move to next Decimal piont 
                 Digit_pointer ++ ;
                 Digit_num = Digit_array[Digit_pointer];}                 
                 strip.setPixelColor(Digit_num, 0,200, 0);                 
                 strip.show();//LEDS.show();
         break; 
         case 18:                                   // exit Clock Menu
                 IR_VAL = 0;
                 Serial.println("end Clock loop and adjust time");
                  Hour = (digit1*10) + digit2;
                  Minute =  (digit3*10) + digit4;
                  Second = 0;
                  
                   Serial.print("time wordt = "); 
                   Serial.print(Hour); Serial.print(' '); Serial.print(Minute); Serial.print(' '); Serial.print(Second); Serial.print(' ');
                   Serial.println();
                Clock.setHour(Hour);
		Clock.setMinute(Minute);
		Clock.setSecond(Second);
                 Menu_num = 1;
                 return Main_menu();
         break; 
       
           
       }
     } 
 }
//-----read clock adjust digits---------------------------------------------- 
void read_clock(){                                                                    
                  hour_h = (Clock.getHour(h12, PM)/10);  
                  hour_l = (Clock.getHour(h12, PM))-(((Clock.getHour(h12, PM))/10)*10);      
                  min_h  = (Clock.getMinute())/10;
                  min_l  = (Clock.getMinute())-(((Clock.getMinute())/10)*10);
                  sec_h  = (Clock.getSecond())/10;
                  sec_l  = (Clock.getSecond())-(((Clock.getSecond())/10)*10);
                  
                  digit1=hour_h;
                  digit2=hour_l;
                  digit3=min_h;
                  digit4=min_l;
                  digit5=sec_h;
                  digit6=sec_l;
                }
//-------Read IR-------Vul IR_VAL-----------------------------------
void read_ir()
  {  //IR_VAL = 0;
      if (irrecv.decode(&results)) 
      { 
        if (results.value == P) 
        { Serial.println("POWER");  IR_VAL = 10;   }
        if (results.value == A) 
        { Serial.println("A");      IR_VAL = 11;   }
         if (results.value == B) 
        { Serial.println("B");      IR_VAL = 12;   }
         if (results.value == C) 
        { Serial.println("C");      IR_VAL = 13;   }
         if (results.value == UP) 
        { Serial.println("UP");     IR_VAL = 14;   }
         if (results.value == DOWN) 
        { Serial.println("DOWN");   IR_VAL = 15;   }
         if (results.value == LEFT) 
        { Serial.println("LEFT");   IR_VAL = 16;   }
         if (results.value == RIGHT) 
        { Serial.println("RIGHT");  IR_VAL = 17;   }
         if (results.value == SELECT) 
        { Serial.println("SELECT"); IR_VAL = 18;   }
             delay(500);
     irrecv.resume();
      } 
  }

//---------------------------------------------------------------
void translate_digits(){                               // translate digit1-2-3-4 values to led's with color settings
 
  Lednum =0;
  segmtloop =0;
  color_scheme = 2; 
        while (segmtloop < 8)                          // translate digit1
        { if (segmtarray [segmtloop][digit1]== 1)
               { run_color_scheme(); 
                 Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum++ ; } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum++ ; }
          segmtloop++ ; 
        }
       
  segmtloop =0;

        while (segmtloop < 8)                          // translate digit2
        { if  (segmtarray [segmtloop][digit2]== 1) 
               { run_color_scheme(); 
                 Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum++ ;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum++ ;  }
           segmtloop++ ; 
        } 
  color_scheme = 3;       
        
  segmtloop =0;

        while (segmtloop < 8)                          // translate digit3
        {  if (segmtarray [segmtloop][digit3]== 1) 
               { run_color_scheme();
                 Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum++ ;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum++ ;  }
           segmtloop++ ; 
        } 
  
 
  segmtloop =0;

        while (segmtloop < 8)                          // translate digit4
        {  if (segmtarray [segmtloop][digit4]== 1) 
               { run_color_scheme();
                 Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum++ ;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum++ ;  }
          segmtloop++ ; 
        } 
        
  color_scheme = 3;
  segmtloop =0;

        while (segmtloop < 8)                          // translate digit5
        {  if (segmtarray [segmtloop][digit5]== 1) 
               { run_color_scheme();
                 Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum++ ;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum++ ;  }
          segmtloop++ ; 
        }

  segmtloop =0;

        while (segmtloop < 8)                          // translate digit6
        {  if (segmtarray [segmtloop][digit6]== 1) 
               { run_color_scheme();
                 Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum++ ;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum++ ;  }
          segmtloop++ ; 
        }
} 
//---------------------------------------------------------------
void translate_digits_no_new_color(){                     // translate digit1-2-3-4 values to led's with static color settings 
  Lednum =0;
  segmtloop =0;

        while (segmtloop < 8)                             // translate digit1
        { if (segmtarray [segmtloop][digit1]== 1)
               { Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum++ ; } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum++ ; }
          segmtloop++ ; 
        }
      
  segmtloop =0;

        while (segmtloop < 8)                              // translate digit2
        { if  (segmtarray [segmtloop][digit2]== 1) 
               { Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum = Lednum + 1;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum++ ;  }
           segmtloop++ ; 
        } 
        
  segmtloop =0;

        while (segmtloop < 8)                               // translate digit3
        {  if (segmtarray [segmtloop][digit3]== 1) 
               { Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum++ ;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum++ ;  }
           segmtloop++ ; 
        } 
 
  segmtloop =0;

        while (segmtloop < 8)                                // translate digit4
        {  if (segmtarray [segmtloop][digit4]== 1) 
               { Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum++ ;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum++ ;  }
          segmtloop++ ; 
        } 
  
  segmtloop =0;

        while (segmtloop < 8)                                // translate digit5
        {  if (segmtarray [segmtloop][digit5]== 1) 
               { Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum++ ;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum++ ;  }
          segmtloop++ ; 
        }

  segmtloop =0;

        while (segmtloop < 8)                                 // translate digit6
        {  if (segmtarray [segmtloop][digit6]== 1) 
               { Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum++ ;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum++ ;  }
          segmtloop++ ; 
        }
} 

//-----------------------------------------------------------------------------
void Stream_LEDdata(){
                        id = 0;
                        while (id < 32)
                          {   strip.setPixelColor(id, Rarray[id], Garray[id],  Barray[id]);   //leds[id] = CRGB(Garray[id], Rarray[id], Barray[id]);             
                              id++; 
                          } 
                        strip.show();
                        delay(10);
                      }
//-----------------------------------------------------------------------------
//void Stream_Setting(){
//                        id = 0;
//                        while (id < 32)
//                          {   strip.setPixelColor(id, Rarray[id], Garray[id],  Barray[id]);   //leds[id] = CRGB(Garray[id], Rarray[id], Barray[id]);             
//                              id++; 
//                          } 
//                        strip.show();    
//                        delay(10);
//                      }                        

//-----run color scheme---------------------------------------------- 
void run_color_scheme(){
           switch (color_scheme){
                            case 1: 
                                  Green =  random(250);
                                  Red =  random(250);
                                  Blue =  random(250);
                            break;
                            case 2:   
                                  Green = random(10,100);
                                  Red =  100;   
                                  Blue = 0;         
                            break;
                            case 3:   
                                  Green = 130;  
                                  Red =  0;   
                                  Blue = random(10,200);     
                            break;
                            case 4:   
                                  Green = 0; 
                                  Red =  random(10,200);   
                                  Blue = 170;     
                            break;    
                        }
            }  
//-----run color scheme---------------------------------------------- 
void run_menu_color(int color){
            switch (color){
                            case 1: 
                                  Green =  0;
                                  Red =  250;
                                  Blue =  0;
                            break;
                            case 2:   
                                  Green = 200;
                                  Red =  200;   
                                  Blue = 0;         
                            break;
                            case 3:   
                                  Green = 0;  
                                  Red =  0;   
                                  Blue = 250;     
                            break;
                            case 4:  
                                  Green = 0; 
                                  Red =  100;   
                                  Blue = 170;     
                            break;   
                            case 5:  
                                  Green = 200; 
                                  Red =  0;   
                                  Blue = 0;     
                            break;       
                        }
            }

