#include <SoftwareSerial.h>


/*
 Temp, I2c, LM92, diag 4x 1" RGBDigit's on a RGBdigitSchield 
   
 The circuit:
 * Code for use on the RGBDigitSchield with LM92 kit 
 * Default LM92 adres = 00 
 * RGBDigit Digit's attached on pin 12 Arduino microcontroller (UNO) 
 * Ad a 470 ohm resistor between pin 12 of the microcontroller and Data in (Di)Pin2 from first RGBDigit 
 * This code is configured for 4 1"RGBDigit's is 32 RGBLED's

 **************************************************************************************************************************************
 
 * NOTE  Do not connect RGBDigit's to a life arduino(UNO) controller                                                                  *
 * NOTE  The NeoPixel's are very sensitive for the correct connection order                                                           *
 * NOTE  See for more info the Basic Connection section on http://learn.adafruit.com/adafruit-neopixel-uberguide/arduino-library      *
  
 **************************************************************************************************************************************
 
 created 2015  
 by RGBDigit < http://rgbdigit.com >
 modified 11 Mrt 2015
 by Coen   RGBDigit
 Version STD_V15.02.02
 
 This code is based on Adafruit_NeoPixel  URL  http://learn.adafruit.com/adafruit-neopixel-uberguide/arduino-library 
 This example code is in the public domain.
*/


// nu met Adafruit_NeoPixel library  
#include "Wire.h"                                            // for using i2c 
#include <SoftwareSerial.h>                                          // for sending debug data to serial monitor  SoftwareSerial
//#include <Serial.h>                                          // for sending debug data to serial monitor  
#include <Adafruit_NeoPixel.h>                               // for using RGB Adafruit neopixels

#define PIN 12                                               // Sending neopixel data to pin12 

// Parameter 1 = number of pixels in strip
// Parameter 2 = pin number (most are valid)
// Parameter 3 = pixel type flags, add together as needed:
//   NEO_KHZ800  800 KHz bitstream (most NeoPixel products w/WS2812 LEDs)
//   NEO_KHZ400  400 KHz (classic 'v1' (not v2) FLORA pixels, WS2811 drivers)
//   NEO_GRB     Pixels are wired for GRB bitstream (most NeoPixel products)
//   NEO_RGB     Pixels are wired for RGB bitstream (v1 FLORA pixels, not v2)
Adafruit_NeoPixel strip = Adafruit_NeoPixel(32, PIN, NEO_GRB + NEO_KHZ800);

////////////////////////////////////////////////////////////////////////////////////////////////////



long randNumber;
const int analogInPin0 = A0;  // Analog input pin that the potentiometer is attached to
const int analogInPin1 = A1;  // Analog input pin that the potentiometer is attached to
const int analogInPin2 = A2;  // Analog input pin that the potentiometer is attached to
const int analogInPin3 = A3;  // Analog input pin that the potentiometer is attached to
int sensorValue1 = 0;        // value read from the pot
int sensorValue2 = 0;        // value read from the pot
int sensorValue3 = 0;        // value read from the pot
int sensorValue4 = 50;        // value read from the pot

byte digit1 = 0;
byte digit11 = 1;
byte digit2 = 0;
byte digit22 = 4; 
byte digit3 = 0;
byte digit4 = 10;
byte digit5 = 0;
byte digit6 = 0;
byte Red = 0;
byte Green = 0;
byte Blue = 0;
byte id = 0;
byte segmtloop = 0;
byte Lednum = 0;
byte Bright = 150;
byte color_scheme = 2;
byte heu = 0;
byte Temppos = 1;
//-------------Color array  48 RGBleds = 6 RGBSegments----------------------------------------------------------------------------------------------------------------------------------------------------
              // a  b  c  d  e  f  g  h |a  b  c  d  e  f  g  h |a  b  c  d  e  f  g  h |a  b  c  d  e  f  g  h |a  b  c  d  e  f  g  h |a  b  c  d  e  f  g  h  
byte Rarray[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};// array van 48
byte Garray[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};// array van 48
byte Barray[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};// array van 48

//------character table------------------------------------------------------------------------------

//            2-dimensional array of segment a,b,c,d,e,f,g,h data:   each character has its own colum
//                                          0 1 2 3 4 5 6 7 8 9 c - off
              byte  segmtarray [8][13] = { {1,0,1,1,0,1,0,1,1,1,1,0,0},    //a             a
                                           {1,1,1,1,1,0,0,1,1,1,0,0,0},    //b          f     b
                                           {1,1,0,1,1,1,1,1,1,1,0,0,0},    //c             g
                                           {1,0,1,1,0,1,1,0,1,1,0,0,0},    //d          e     c
                                           {1,0,1,0,0,0,1,0,1,0,0,0,0},    //e             d
                                           {1,0,0,0,1,1,1,0,1,1,1,0,0},    //f
                                           {0,0,1,1,1,1,1,0,1,1,1,1,0},    //g  
                                           {0,0,0,0,0,0,0,0,0,0,0,0,0},};  //h   

//-----I2c settings---------------------------------------------- 
              char lm92address = 0x48;      //Adress 0 A1 A0 are grounded
              char buffer[2];
              int tempcode;
              float temp;
//---------------------------------------------------------------

void setup() {
              strip.begin();
              strip.show();                     // Initialize all pixels to 'off'
              strip.setBrightness(Bright);      // For safety (to prevent too high of a power draw), the test case defaults to 40
                      
                    //---------------------------------------------------------------
            	    // sanity check delay - allows reprogramming if accidently blowing power w/leds
               	    delay(500);
                    Wire.begin();
                    Serial.begin(9600); // open een seriele port
             }

//---------Main loop---------------------------------------------------------------------------

void loop() { 
              delay(2000);                                       // 2 second interval      
              //sensorValue1 = analogRead(analogInPin0); 
              //sensorValue2 = analogRead(analogInPin1); 
              //sensorValue3 = analogRead(analogInPin2);
              //sensorValue4 = analogRead(analogInPin3);           // read trimmer4    (brightness value)
              //sensorValue1 /= 4;                               // converter 0-1023 naar 0-255
              //sensorValue2 /= 4;                               // converter 0-1023 naar 0-255
              //sensorValue3 /= 4;                               // converter 0-1023 naar 0-255
              //sensorValue4 /= 4;                                 // converter 0-1023 naar 0-255
              
              Bright = sensorValue4;        
              strip.setBrightness(Bright);                       //  LEDS.setBrightness(sensorValue4);
              
                    read_temp();                                 // read temperature and fill digit1,digit2,digit3,digit4 (unit conversion)
                    temp_to_color();                             // convert temp value to color  
                    translate_digits_no_new_color();       // this one         // shows temp versus color color's 
                    //translate_digits();                  // or this one      // shows random color scheme colors
                    Stream_LEDdata();                            // stream send led data
            }                                             
//---------end main loop----------------------------------------------------------------------

//-----read I2c temp --------------------------------------------------- 
void read_temp(){
  delay(20);
  Wire.requestFrom(lm92address,2); 
  if (Wire.available()) 
  {
    for (int i=0; i<2; i++) {
      buffer[i]= Wire.read();
    }
tempcode= ((buffer[0] << 8) + buffer[1]) >>3;
temp = tempcode * 0.0625;
 if (temp <= 0)
    {temp = temp * -1;
     heu = temp;
     Temppos = 0;}                              // temp is negatif
  else
    {heu = temp;
     Temppos = 1;}                              // temp is positif

  if (Temppos == 1)                             // unit conversion when temp is pos   each digit get is own value
        {    
         digit1= temp/10;
         digit11 =digit1;
         if (digit1 == 0){digit1=12;} 
             digit2=temp-(digit11*10);
  
             int temp2=temp;
             int digit33=(temp-temp2)*1000;
        
             digit3 = digit33/100;
             digit4 = 10;
         }
  else   {                                      // unit conversion when temp is neg   each digit get is own value
           digit1 = 11;      
                  
           digit2= temp/10;
            digit22 = digit2;  
            if (digit2 == 0){digit2=12;}
            
           digit3=temp-(digit22*10);
           int temp2=temp;
           int digit33=(temp-temp2)*1000;
           digit4 = digit33/100;
         }
}
}  
//-----temp to color convertion---------------------------------------------- 
void temp_to_color(){
 
   Serial.println("temp to color convertion "); 
   Serial.print("heu before "); Serial.println(heu);
   if (Temppos == 0 ) { Serial.print("temp (posneg) is nu neg "); Serial.println(Temppos);
               Blue = heu * 5;
               Green = 250 - Blue; 
               Red = 0;} 
    else {Serial.print("temp (posneg) is nu pos "); Serial.println(Temppos);
                           if (heu > 75) { Blue=0; Red=250; Green=0;}
                          else { 
                                Blue = 0;
                                Red = heu * 3;
                                Green = 250 - Red;  } }  
    
    Serial.println(" ");  
    Debug_data();
}  
  
//---------------------------------------------------------------
void translate_digits(){                               // translation digit1-2-3-4 to appropriate segment LEDs  Gives random color's from color scheme
 
  Lednum =0;
  segmtloop =0;
  color_scheme = 1; 
        while (segmtloop < 8)                          // translate digit1 
        { if (segmtarray [segmtloop][digit1]== 1)
               { run_color_scheme();                   
                 Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum = Lednum + 1; } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum = Lednum + 1; }
          segmtloop = segmtloop + 1; 
        }
     
        
  segmtloop =0;

        while (segmtloop < 8)                        // translate digit2
        { if  (segmtarray [segmtloop][digit2]== 1) 
               { run_color_scheme(); 
                 Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum = Lednum + 1;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum = Lednum + 1;  }
           segmtloop = segmtloop + 1; 
        } 
  color_scheme = 3;       
        
  segmtloop =0;

        while (segmtloop < 8)                        // translate digit3
        {  if (segmtarray [segmtloop][digit3]== 1) 
               { run_color_scheme();
                 Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum = Lednum + 1;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum = Lednum + 1;  }
           segmtloop = segmtloop + 1; 
        } 
  
 
  segmtloop =0;

        while (segmtloop < 8)                        // translate digit4
        {  if (segmtarray [segmtloop][digit4]== 1) 
               { run_color_scheme();
                 Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum = Lednum + 1;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum = Lednum + 1;  }
          segmtloop = segmtloop + 1; 
        } 
        
  color_scheme = 4;                                  // purple blue
  segmtloop =0;

        while (segmtloop < 8)                        // translate digit5
        {  if (segmtarray [segmtloop][digit5]== 1) 
               { run_color_scheme();
                 Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum = Lednum + 1;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum = Lednum + 1;  }
          segmtloop = segmtloop + 1; 
        }

  segmtloop =0;

        while (segmtloop < 8)                        // translate digit6
        {  if (segmtarray [segmtloop][digit6]== 1) 
               { run_color_scheme();
                 Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum = Lednum + 1;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum = Lednum + 1;  }
          segmtloop = segmtloop + 1; 
        }
} 
//---------------------------------------------------------------
void translate_digits_no_new_color(){                               // translation digit1-2-3-4 to appropriate segment LEDs 
                                                                    // color comes from void temp_to_color who tranfers temp to color
 
  Lednum =0;
  segmtloop =0;

        while (segmtloop < 8)                        // translate digit1
        { if (segmtarray [segmtloop][digit1]== 1)
               { Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum = Lednum + 1; } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum = Lednum + 1; }
          segmtloop = segmtloop + 1; 
        }
     
  segmtloop =0;

        while (segmtloop < 8)                        // translate digit2
        { if  (segmtarray [segmtloop][digit2]== 1) 
               { Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum = Lednum + 1;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum = Lednum + 1;  }
           segmtloop = segmtloop + 1; 
        } 
      
  segmtloop =0;

        while (segmtloop < 8)                        // translate digit3
        {  if (segmtarray [segmtloop][digit3]== 1) 
               { Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum = Lednum + 1;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum = Lednum + 1;  }
           segmtloop = segmtloop + 1; 
        } 
  
  segmtloop =0;

        while (segmtloop < 8)                        // translate digit4
        {  if (segmtarray [segmtloop][digit4]== 1) 
               { Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum = Lednum + 1;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum = Lednum + 1;  }
          segmtloop = segmtloop + 1; 
        } 

  segmtloop =0;

        while (segmtloop < 8)                        // translate digit5
        {  if (segmtarray [segmtloop][digit5]== 1) 
               { Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum = Lednum + 1;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum = Lednum + 1;  }
          segmtloop = segmtloop + 1; 
        }

  segmtloop =0;

        while (segmtloop < 8)                        // translate digit6
        {  if (segmtarray [segmtloop][digit6]== 1) 
               { Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum = Lednum + 1;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum = Lednum + 1;  }
          segmtloop = segmtloop + 1; 
        }
} 

//-----------------------------------------------------------------------------
void Stream_LEDdata(){
                        id = 0;
                        while (id < 32)                                                       // stream led data  from  Color array's 
                          {   strip.setPixelColor(id, Rarray[id], Garray[id],  Barray[id]);   // leds[id] = CRGB(Garray[id], Rarray[id], Barray[id]);             
                              id++; 
                          } 
   
                        if (Temppos == 1){                                                    
                            strip.setPixelColor(15, Red, Green,  Blue);}                      // set decimal point led 15 when temp is poss 
                        else {
                            strip.setPixelColor(23, Red, Green,  Blue);}                      // set decimal point led 23 when temp is neg
                        strip.show();                                                         // LEDS.show();   
                        delay(10);}
//-----------------------------------------------------------------------------
void Debug_data(){
//    Serial.println("start");
//      Serial.print(Lednum)    ;Serial.print(" lednum \t") ; 
//       Serial.print(segmtloop) ;Serial.print("segmtloop \t") ;
//       Serial.print(digit1) ;  ;Serial.print("digit1 \t") ;
//       Serial.print(segmtarray [digit1][segmtloop]); ;Serial.print("segmtarray  \t") ; 
//       Serial.print(segmtarray [y][x]); ;Serial.print("segmtarray  \t") ; 
 Serial.print("    green\t"); Serial.print(Green); // Serial.print(Rarray[1]);
 Serial.print("    red\t"); Serial.print(Red); 
 Serial.print("    blue\t"); Serial.print(Blue);
 Serial.print("    heu "); Serial.println(heu);  //Serial.println(id);
Serial.println(" ");
}  
//-----run color scheme---------------------------------------------- 
void run_color_scheme(){                                                                    // sets color depending which color scheme is used
  switch (color_scheme){
    case 1:                                       // random color's
          Green =  random(250);
          Red =  random(250);
          Blue =  random(250);
          break;
    case 2:                                       //  red / yellow
          Green = random(10,100);
          Red =  100;   
          Blue = 0;         
    break;
    case 3:                                       // light blue / green
          Green = 130;  
          Red =  0;   
          Blue = random(10,200);     
    break;
    case 4:                                       // purple / blue               
          Green = 0; 
          Red =  random(10,200);   
          Blue = 170;     
    break;    
  }
}            

