
/*
 * Hardware requirements 
 * 1x 4x 1" RGBDigit's on a RGBdigitSchield
 * 1x DS3231 clock unit on the RGBDigitshield 
 * 1x IR remote set on the RGBDigitshield works fine with the red remote see URL list 
 * 1x Arduino UNO
 
 * Arduino 16.1 with Adafruit_NeoPixel and IRremote library
 
 * Power Arduino up  Load software
 * Use Power key for jump into the menu
 * press B (menu B) for setting brightness or press C (menu C) for clock adjstment   button A has no function jet
 * in Menu B use arrow up/down to adjust brightness  use O button to leave the menu
 * In Menu C use arrow left/right to choose digit to adjust and use arrow up/down to set digit
 * in Menu C use O button to store new time or the power button to leave C Menu
  
 *****************************************Important*********************************************************************************************
 *
 * Important NOTE  Do not connect RGBDigitshield to a life arduino(UNO) controller 
 *
 *****************************************Important*********************************************************************************************
 * NOTE  The NeoPixel's are very sensitive for the correct connection order                                                           *
 * NOTE  See for more info the Basic Connection section on http://learn.adafruit.com/adafruit-neopixel-uberguide/arduino-library      *
  
 **************************************************************************************************************************************
 
 created 2015   by RGBDigit < http://rgbdigit.com >
 modified 19 Mrt 2015
 by Coen   RGBDigit
 Version SCLD_V15.01.01
 
 This code is based on Adafruit_NeoPixel  URL  http://learn.adafruit.com/adafruit-neopixel-uberguide/arduino-library 
 and a remote control.                    URL  http://floris.cc/shop/en/general-components/803-infrared-remote-control-.html 
 This example code is in the public domain.

*/

#include "Wire.h"                                             
#include <Adafruit_NeoPixel.h>                               
//#include <IRremote.h>
//#include <DS3231.h>

#define PIN 12                                             // Sending neopixel data to Pin 12 

// Parameter 1 = number of pixels in strip
// Parameter 2 = pin number (most are valid)
// Parameter 3 = pixel type flags, add together as needed:

Adafruit_NeoPixel strip = Adafruit_NeoPixel(32, PIN, NEO_GRB + NEO_KHZ800);

////////////////////////////////////////////////////////////////////////////////////////////////////

byte digit1 = 12; byte digit2 = 12; byte digit3 = 12; byte digit4 = 12; byte digit5 = 12; byte digit6 = 12;

byte Red = 0; byte Green = 0; byte Blue = 0;
byte id = 0;
byte segmtloop = 0;
byte Lednum = 0;
byte Bright = 150; 
byte color_scheme = 4;
int  count_nr = 0;
int  hundreds = 0; int tenths = 0;

//-------------Color array  48 RGBleds = 6 RGBSegments----------------------------------------------------------------------------------------------------------------------------------------------------
              // a  b  c  d  e  f  g  h |a  b  c  d  e  f  g  h |a  b  c  d  e  f  g  h |a  b  c  d  e  f  g  h |a  b  c  d  e  f  g  h |a  b  c  d  e  f  g  h  
byte Rarray[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};// array van 48
byte Garray[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};// array van 48
byte Barray[] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};// array van 48

//------character table------------------------------------------------------------------------------

//            2-dimensional array of segment a,b,c,d,e,f,g,h data:   each character has its own colum
//                                          0 1 2 3 4 5 6 7 8 9 c - off
              byte  segmtarray [8][13] = { {1,0,1,1,0,1,0,1,1,1,1,0,0},    //a             a
                                           {1,1,1,1,1,0,0,1,1,1,0,0,0},    //b          f     b
                                           {1,1,0,1,1,1,1,1,1,1,0,0,0},    //c             g
                                           {1,0,1,1,0,1,1,0,1,1,0,0,0},    //d          e     c
                                           {1,0,1,0,0,0,1,0,1,0,0,0,0},    //e             d
                                           {1,0,0,0,1,1,1,0,1,1,1,0,0},    //f
                                           {0,0,1,1,1,1,1,0,1,1,1,1,0},    //g  
                                           {0,0,0,0,0,0,0,0,0,0,0,0,0},};  //h   


void setup() {
               strip.begin();
               strip.show();                            // Initialize all pixels to 'off'
               strip.setBrightness(Bright);      	// For safety (to prevent too high of a power draw), the test case defaults to 40
                      
               delay(500);                              // sanity check delay - allows reprogramming if accidently blowing power w/leds
               Wire.begin();
               Serial.begin(9600);                      // open een seriele port 
              }

//----------Main loop---------------------------------------------------------------------------

void loop() { 
               delay(50);                                         
             count_nr = 0;
               split_count_nr();
               
 
               if (color_scheme == 0)                   // loop color_scheme from 0 to 4
                    {color_scheme = 4;}
               else 
                    {color_scheme-- ;}         
         
               
               while (count_nr < 350 ){
                  delay(50);                            // counting speed
                  Serial.print("color_scheme =  "); Serial.println(color_scheme );
                  run_color_scheme();      
                  translate_digits();                    // translate digit1 values to led's with color settings
                  count_nr++;                              // increment digit1 + 1
                  split_count_nr();
                  Stream_LEDdata();                      // shift led data to pin 12 refresh colors
               }
            }                                             
//---------end main loop----------------------------------------------------------------------
void split_count_nr(){
                   hundreds = count_nr % 1000;
                   tenths = hundreds % 100;
                   digit4 = tenths %10;                            // eenheden
                   digit3 = (tenths - digit4)/10;                  // tien tallen
                   if (digit2 == 13 ){
                     if (digit3 == 0) {digit3 = 12;}
                   }
                   digit2 = (hundreds - tenths)/100;               // honderd tallen
                   if (digit2 == 0) {digit2 = 12;}
                   digit1 = 12;   
}
//---------------------------------------------------------------
void translate_digits(){                               // translate digit1-2-3-4 values to led's with color settings
 
  Lednum =0;
  segmtloop =0;

        while (segmtloop < 8)                          // translate digit1
        { if (segmtarray [segmtloop][digit1]== 1)
               { run_color_scheme(); 
                 Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum++ ; } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum++ ; }
          segmtloop++ ; 
        }
       
  segmtloop =0;

        while (segmtloop < 8)                          // translate digit2
        { if  (segmtarray [segmtloop][digit2]== 1) 
               { run_color_scheme(); 
                 Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum++ ;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum++ ;  }
           segmtloop++ ; 
        } 
    
        
  segmtloop =0;

        while (segmtloop < 8)                          // translate digit3
        {  if (segmtarray [segmtloop][digit3]== 1) 
               { run_color_scheme();
                 Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum++ ;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum++ ;  }
           segmtloop++ ; 
        } 
  
 
  segmtloop =0;

        while (segmtloop < 8)                          // translate digit4
        {  if (segmtarray [segmtloop][digit4]== 1) 
               { run_color_scheme();
                 Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum++ ;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum++ ;  }
          segmtloop++ ; 
        } 
        

  segmtloop =0;

        while (segmtloop < 8)                          // translate digit5
        {  if (segmtarray [segmtloop][digit5]== 1) 
               { run_color_scheme();
                 Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum++ ;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum++ ;  }
          segmtloop++ ; 
        }

  segmtloop =0;

        while (segmtloop < 8)                          // translate digit6
        {  if (segmtarray [segmtloop][digit6]== 1) 
               { run_color_scheme();
                 Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum++ ;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum++ ;  }
          segmtloop++ ; 
        }
} 
//---------------------------------------------------------------
void translate_digits_no_new_color(){                     // translate digit1-2-3-4 values to led's with static color settings 
  Lednum =0;
  segmtloop =0;

        while (segmtloop < 8)                             // translate digit1
        { if (segmtarray [segmtloop][digit1]== 1)
               { Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum++ ; } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum++ ; }
          segmtloop++ ; 
        }
      
  segmtloop =0;

        while (segmtloop < 8)                              // translate digit2
        { if  (segmtarray [segmtloop][digit2]== 1) 
               { Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum = Lednum + 1;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum++ ;  }
           segmtloop++ ; 
        } 
        
  segmtloop =0;

        while (segmtloop < 8)                               // translate digit3
        {  if (segmtarray [segmtloop][digit3]== 1) 
               { Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum++ ;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum++ ;  }
           segmtloop++ ; 
        } 
 
  segmtloop =0;

        while (segmtloop < 8)                                // translate digit4
        {  if (segmtarray [segmtloop][digit4]== 1) 
               { Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum++ ;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum++ ;  }
          segmtloop++ ; 
        } 
  
  segmtloop =0;

        while (segmtloop < 8)                                // translate digit5
        {  if (segmtarray [segmtloop][digit5]== 1) 
               { Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum++ ;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum++ ;  }
          segmtloop++ ; 
        }

  segmtloop =0;

        while (segmtloop < 8)                                 // translate digit6
        {  if (segmtarray [segmtloop][digit6]== 1) 
               { Garray[Lednum] = Green;  Rarray[Lednum] = Red; Barray[Lednum] = Blue ;
                 Lednum++ ;  } 
          else { Garray[Lednum] = 0; Rarray[Lednum] = 0; Barray[Lednum] = 0;
                 Lednum++ ;  }
          segmtloop++ ; 
        }
} 

//-----------------------------------------------------------------------------
void Stream_LEDdata(){
                        id = 0;
                        while (id < 48)
                          {   strip.setPixelColor(id, Rarray[id], Garray[id],  Barray[id]);   //leds[id] = CRGB(Garray[id], Rarray[id], Barray[id]);             
                              id++; 
                          } 
                        strip.show();
                        delay(10);
                      }
//-----------------------------------------------------------------------------

//-----run color scheme---------------------------------------------- 
void run_color_scheme(){
           switch (color_scheme){
                            case 1: 
                                  Green =  random(250);
                                  Red =  random(250);
                                  Blue =  random(250);
                            break;
                            case 2:   
                                  Green = random(10,100);
                                  Red =  100;   
                                  Blue = 0;         
                            break;
                            case 3:   
                                  Green = 130;  
                                  Red =  0;   
                                  Blue = random(10,200);     
                            break;
                            case 4:   
                                  Green = 0; 
                                  Red =  random(10,200);   
                                  Blue = 170;     
                            break;    
                        }
            }  


